include(../conf.pri)
include(../defaults.pri)

TEMPLATE = app
CONFIG += warn_on \
          thread \
          qt
LIBS += -lpoppler-qt4

DEFINES += APPVERSION=\\\"$${APPVERSION}\\\"
DEFINES += KTIKZ_INSTALL_TRANSLATIONS=\\\"$${TRANSLATIONSDIR}\\\"

### Input

defineReplace(headerFiles) {
	names = $$ARGS
	headerNames =

	for(name, names) {
		baseName = $$replace(name, "\.cpp", "")
		headerName = $${baseName}.h
		exists($$headerName) {
			headerNames += $$headerName
		}
	}
	return($$headerNames)
}

SOURCES += aboutdialog.cpp \
           appearancewidget.cpp \
           configdialog.cpp \
           ktikz.cpp \
           latexloghighlighter.cpp \
           latexlogtextedit.cpp \
           main.cpp \
           tikzcommandinserter.cpp \
           tikzhighlighter.cpp \
           tikzpngpreviewer.cpp \
           tikzpreview.cpp
HEADERS += $$headerFiles($$SOURCES)
RESOURCES = application.qrc
TRANSLATIONS = ktikz_de.ts ktikz_fr.ts

### Output

defineReplace(qmFiles) {
	names = $$ARGS
	qmfiles =

	for(name, names) {
		baseName = $$replace(name, "\.ts", "")
		qmName = $${baseName}.qm
		exists($$qmName) {
			qmfiles += $$qmName
		}
	}
	return($$qmfiles)
}

TARGET = ktikz
target.path = $${BINDIR}
INSTALLS += target

translations.path = $${TRANSLATIONSDIR}
translations.files = $$qmFiles($$TRANSLATIONS)
INSTALLS += translations

unix:!macx {
	desktop.path = $${DESKTOPDIR}
	desktop.files = ktikz.desktop
	INSTALLS += desktop
}
