/***************************************************************************
 *   Copyright (C) 2007 by Glad Deschrijver                                *
 *   florian@hackenberger.at                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TIKZCOMMANDINSERTER_H
#define TIKZCOMMANDINSERTER_H

#include <QObject>
#include <QStringList>

class QAction;
class QMenu;
class QTextEdit;
class QTextCharFormat;
class HighlightingRule;

class TikzCommandInserter : public QObject
{
	Q_OBJECT
public:
	TikzCommandInserter(QTextEdit *textEdit, QObject *parent = 0);

	QMenu *getMenu();
	QMap<QString, QTextCharFormat> getDefaultTextCharFormats();
	QStringList getTranslatedTypeNames();
	QStringList getTypeNames();
	QVector<HighlightingRule> getHighlightingRules();
	void insertTag(const QString &tag, int dx = 0, int dy = 0);

private:
	QAction *newCommand(const QString &name, const QString &command, int dx, int dy, int type = 0);

	QTextEdit *mainEdit;
	QMenu *tikzMenu;
	QStringList nameList;
	QStringList commandList;
	QList<int> dxList;
	QList<int> dyList;
	QList<int> typeList;

	QStringList typeNames;

private slots:
	void insertTag();
};

#endif
