/***************************************************************************
 *   Copyright (C) 2007 by Glad Deschrijver                                *
 *   Glad.Deschrijver@UGent.be                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TIKZPREVIEW_H
#define TIKZPREVIEW_H

#include <QGraphicsView>

class QComboBox;
class QToolBar;

#define UNSTABLE_POPPLER_QT4
#include <poppler-qt4.h>

class TikzPreview : public QGraphicsView
{
	Q_OBJECT
public:
	TikzPreview(QWidget *parent = 0);

	virtual QSize sizeHint() const;
	void pixmapUpdated(Poppler::Document *tikzPdfDoc);
	QList<QAction*> getActions();
	QToolBar *getViewToolBar();
	QPixmap *getPixmap();

protected:
	void contextMenuEvent(QContextMenuEvent *event);

private slots:
	void setZoomFactor();
	void zoomIn();
	void zoomOut();
	void showPreviousPage();
	void showNextPage();

private:
	void createActions();
	void createViewToolBar();
	void showPdfPage();

	QPixmap *tikzImage;
	QGraphicsScene *tikzScene;
	QGraphicsPixmapItem *tikzPixmapItem;

	QToolBar *viewToolBar;
	QComboBox *zoomCombo;
	QAction *zoomInAct;
	QAction *zoomOutAct;
	QAction *previousPageAct;
	QAction *nextPageAct;

	Poppler::Document *tikzPdfDoc;
	int currentPage;
	double zoomFactor;
	double minZoomFactor;
	double maxZoomFactor;
};

#endif
